/********************************************
   global procedures used in many files
*********************************************/


#include <malloc.h>
#include <stdio.h>
#include <ctype.h>

#include "common.h"
#include "globalProcs.h"

char * xmalloc (unsigned size)
{
  register char *ptr = (char *) malloc (size);
  if (ptr != 0) return (ptr);
  {
     printf ("\nOut of memory.\n");
     exit(1);
  }
  /*NOTREACHED*/
  return 0;
}


char * xrealloc (char *ptr, unsigned size)
{
  int prevSize = sizeof (ptr);
  ptr = (char *) realloc (ptr,size);
  if (sizeof (ptr) != prevSize )
     return (ptr);
  else
  {
     printf ("\nCould not realloc memory.\n");
     exit(1);
  }
  /*NOTREACHED*/
  return 0;
}

/****************************************************************
 'ptr' is added to the end of the list pointed to by 'listHead'
*****************************************************************/

extern void addToList ( struct ListOfItems **listHead, struct item *ptr )
{
   struct ListOfItems *p;
   
   if ( *listHead )
   {
      p = *listHead;
   
      while (p->next)
         p = p -> next;
   
      {
         struct ListOfItems *newP;
      
         newP = ( struct ListOfItems *) xmalloc ( sizeof (struct ListOfItems) );
         newP -> itemPtr = ptr;
         newP -> next = NULL;
         p -> next = newP;
      }
   }
   else
   {
      p = ( struct ListOfItems *) xmalloc ( sizeof (struct ListOfItems) );
      p -> itemPtr = ptr;
      p -> next = NULL;
      *listHead = p;
      return;
   }
   
}

extern struct item * indexList ( struct ListOfItems *ptr, int index )
{
   int i;
   for ( i=0; i < index; i++ )
   {
      if ( ptr )
         ptr = ptr -> next;
      else
         printf ("\n Error 1 in function 'indexList' . Quiting!\n" );
         
   }
   return  ptr -> itemPtr;
}


extern BOOLEAN quoteString ( char str[] )
{
   int i;
   int len = strlen (str);
   
   for ( i=0; i < len; i++ )
      if ( isspace ( str[i] ) )
         return TRUE;

   return FALSE;
}
