/***************************************************
Interface to support.c

declarations of procs
***************************************************/

#ifndef SUPPORT_H
#define SUPPORT_H

#include <stdio.h>

#include "common.h"

extern void adjustContainLevelAssignments ( struct ListOfItems *, int );
extern void view ( struct item *, char * );
extern void viewStructure ( struct SystemPointers * );
extern void getSSname ( char *, char * );
extern void outputLayout ( struct item *, FILE * );
extern BOOLEAN isInt (char *);
extern void createAndSetRoot ( struct Data *hash, struct SystemPointers *graphPtrs );
extern void setSubSystemPtr ( struct Data *, struct SystemPointers *, char * , char *);
extern void initItem ( struct item * );
extern void getToken ( char [], FILE * );
extern void assignParentInfo ( struct item * );

#ifdef LSADJUST

  extern void identifyNewAndOldEntities ( struct Data *, struct SystemPointers *, struct Data *, struct SystemPointers * );

#endif 


#if defined(LSADJUST) || defined(LSDIFF)

  extern void copyAttributeValues ( struct item * );
  extern BOOLEAN isReal ( char *);
  extern void identifyClientsAndServers ( struct item *, struct item * );
  extern BOOLEAN shrink ( struct item * , struct ContainerInfo *, float, float );
  extern BOOLEAN shrinkClientOrServer ( struct item *, struct ContainerInfo *, enum TypesInModel, float );
  extern BOOLEAN collisionDetect ( struct item *, struct item * );
  

#endif /***** LSADJUST || LSDIFF *****/


#endif 
