/***************************************************
Interface to HashRoutines.c

declarations of external procs and vars 
***************************************************/

#ifndef HASHROUTINES_H
#define HASHROUTINES_H

#include "common.h"

/*********************************************
   EXTERNAL FUNCTION DECLARATIONS
**********************************************/
extern struct item * searchHash( struct Data *hash, char *token );
extern void addItemToHashTable ( struct Data *hash, struct item *ptrToItem );
extern void initHashTable ( struct Data *hash );
extern void cleanUp ( struct Data *hash );
extern void viewHashTable ( struct Data *hash );
extern int hashIndex ( char *token );



#endif
